
/*
   Background Sound Player - KDE kaudio

   Copyright 1998 by Kurt Siegl <007@netrek.org>
   Permission to use, modify, copy and distribute this software without
   fee is hereby granted as long as this notice is left here.
*/

#include <signal.h>
#include <stdlib.h>

#include <qapp.h>
#include "Control.h"

KAudio *player=0;
struct shm_sound *shared_data=0;

static void StopSoundI(int);
static void StartSoundI(int);

int 
main( int argc, char **argv )
{
  QApplication a( argc, argv );

  int shmid, returnpid;

  if (argc != 3)		// Usage: bgsndplay shmID parrentPID
    {
      fatal("This program requires 2 arguments.\nBut why are you running it anyway :->");
    }

  shmid = atoi (argv[1]);
  returnpid = atoi (argv[2]);
 
  player = new KAudio();
  CHECK_PTR(player);

  Control *ctrl = new Control(shmid, returnpid);
  CHECK_PTR(ctrl);

  player->setSignals(true);
  QObject::connect( player, SIGNAL(playFinished()), ctrl, SLOT(idle()) );

  signal (SIGUSR1, StopSoundI);
  signal (SIGUSR2, StartSoundI);

  ctrl->sigRet(0);

  return a.exec();
}


static void 
StopSoundI (int sig)
{
  if (shared_data->play_sound)
    {
      player->stop();
      shared_data->play_sound = false;
    }
  signal (SIGUSR1, StopSoundI);
}

static void 
StartSoundI (int sig)
{
  char *name;

  // StopSoundI ();
  name = shared_data->name;
  if (player->play(name))
    {
      // debug("Playing %s",name);
      shared_data->play_sound = true;
    }
  else
    {
      warning("Can't start %s", name);
      shared_data->play_sound = false;
      //  return;
    }

  signal (SIGUSR2, StartSoundI);
  return;
}




